/*
===============================================================================
						Bezier Spline Experiments
						Justin Reynen (Mr.Oreo) 1999

	I want to try making some basic curves using Quadratic and Cubic
Bezier splines, whose functions are derived from the Bersteins basis
function.

  

DirectDraw does all the work :)

===============================================================================
*/

#include <WinInit.h>
#include "dd.h"

#define QUARTIC
//#define CUBIC
//#define QUADRATIC

typedef struct sPoint
{
	int x;
	int y;

} POINT2D;




int Game_Init()
{
	DirectDrawInit(main_window_handle);
	
	
	
return(0);
}	
	
int Game_Main()
{
	float x,y;

	do
	{
#ifdef CUBIC
		//////////////////////////////////////////////////////////
		///GRAPH EACH OF THE 4 BASIS FUNCTION IN A CUBIC SPLINE///
		//////////////////////////////////////////////////////////
		
		for(x = 0; x <= 1; x += 0.01)
		{
			y = x*x*x; 	
			DDPutPixel((800*x),(640*y),RGB16(31,0,0));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = 3*x*x*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(0,31,0));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = 3*x*(1-x)*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(0,0,31));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = (1-x)*(1-x)*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(31,31,31));
		}
#endif
#ifdef QUADRATIC
		//////////////////////////////////////////////////////////////
		///GRAPH EACH OF THE 3 BASIS FUNCTION IN A QUADRATIC SPLINE///
		//////////////////////////////////////////////////////////////
		
		for(x = 0; x <= 1; x += 0.01)
		{
			y =	x*x; 	
			DDPutPixel((800*x),(640*y),RGB16(31,0,0));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = 2*x*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(0,31,0));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = (1-x)*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(0,0,31));
		}
#endif
#ifdef QUARTIC

		/////////////////////////////////////////////////////////////
		///GRAPH EACH OF THE 5 BASIS FUNCTIONS IN A QUARTIC SPLINE///
		/////////////////////////////////////////////////////////////

		for(x = 0; x <= 1; x += 0.01)
		{
			y = x*x*x*x; 	
			DDPutPixel((800*x),(640*y),RGB16(31,0,0));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = 4*x*x*x*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(0,31,0));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = 6 * x*x * (1-x)*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(0,0,31));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = 4 * x * (1-x)*(1-x)*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(31,31,31));
		}

		for(x = 0; x <= 1; x += 0.01)
		{
			y = (1-x)*(1-x)*(1-x)*(1-x); 	
			DDPutPixel((800*x),(640*y),RGB16(0,31,31));
		}







#endif

	}
	while(!KEY_DOWN(VK_ESCAPE));


return(0);
}

int Game_Shutdown()
{
	DirectDrawShutdown();
	

return(0);
}


